#[allow(dead_code)]

use serde::{Serialize};
use serde::de::DeserializeOwned;

pub mod models;

pub trait GeoffreyDatabaseModel: Serialize + DeserializeOwned {
    fn id(&self) -> Option<u64>;
    fn set_id(&mut self, id: u64);
    fn tree() -> String;

    fn try_from_bytes(v: &[u8]) -> Result<Self, serde_json::Error> {
        Ok(serde_json::from_slice::<Self>(v)?)
    }
}

